main:
  gosub DrawWall
  rLocate 20+random(300),550
  rInvisible green,yellow
  LineWidth 2
  rPen down  
    repeat
    call FaceBeacon(yellow)
    call MoveToBeacon(yellow,found)
    if !found then call FollowWall(300)
  until found
end

DrawWall:
  // main obstacle
  circle 300,300,600,400,blue,blue
  circle 350,250,550,400,blue,blue
  circle 360,200,400,300,blue,blue
  circle 350,350,550,450,white,white
  // new obstacle
  circle 120,450,325,500,blue,blue
  circle 700,100,750,150,yellow,yellow
return

FindWall:
  while not(rFeel()&13)
    rForward 1
  wend
return

sub FollowWall(HowFar)  
  rTurn 60   
  for i=1 to HowFar
    d=rFeel()   
    if d&4        
      rTurn 45  // fast turn  
    elseif d=16   
      rTurn -1  // slow turn
    elseif d=24 
      rturn 1   // slow turn
    elseif d=0   
      rTurn -15 // medium turn
    elseif d=8      
      rTurn 15  // medium turn
    endif
    rforward 1
  next
return

sub FaceBeacon(c)
  while !rBeacon(c)
    rTurn 1
  wend
return

sub MoveToBeacon(c,&f)
  while 1
    if rSense(yellow)
      f=true
      return
    endif
    if rFeel()&14
      f=false
      break;
    endif
    if rBeacon(c) 
      rTurn 1
    else
      rTurn -1
    endif 
    rForward 1  
  wend
return




