/*******************************************************************
* Both of the include files (below) are simple RobotBASIC programs *
* and may be opened and edited.  You MUST modify the parameters to *
* match what YOUR robot needs.  For example, change the PORT # of  *
* the virtual serial port used for your Bluetooth link. You should *
* also setup what sensors you are using or problems may occur. If  *
* your Init file says you have a compass, and you don't, then the  *
* RROS will hang up trying to communicate with it. You can make    *
* your own custom Init files that handle robots with any motor and *
* sensor configurations. Depending on the weight and batteries     *
* used by your robot, you may also need to modify the various      *
* speed parameters.                                                *
*                                                                  *
* Once you create the appropriate Init file, your robot can be     *
* controlled as easily as the RobotBASIC simulator.  Read the RROS *
* manual (free download) for more detailed information.            *
*                                                                  *
* The following demonstration program will move the robot forward  *
* a little, then back, before going into a loop to continually     *
* print the values for the FEEL, BUMP, and RANGE sensors.  Move    *
* your hand around the robot and watch these readings change.      *
********************************************************************/
#include "RROScommands.bas"
#include "InitializationRoutines.bas"
gosub InitRROScommands // found in RROScommands.bas
gosub InitRB9robot // use the initialization routine for YOUR robot
rForward 50
rForward -50
rTurn 90
xyString 100,80,"rFEEL     rBUMPER      rRANGE"            
while 1
 rForward 0 // any 'movement' will update sensor readings
 xyString 100,100, rFeel();""; rBumper()&14;"";rRange();""
 // the &14 above is because we have no rear bumper on our RB-9
wend
end

     


