
Real=false // set to TRUE to control real robot

if Real
  gosub RealInitialization
else
  gosub SimulationInitialization
endif

while 1
  rForward 1
  d = rFeel()
  if d&3   // either of the right sensors
    rTurn -90-Random(30)
  elseif d&24 // either of the left sensors 
    rTurn 90+Random(30)
  endif
wend

SimulationInitialization:
  rLocate 400,300,Random(360)
return

RealInitialization:
  #include "RROScommands.bas"
  gosub InitRROScommands
  rCommPort 44 //use your port number
  rLocate 0,0
  rCommand(MotorSetup, SMALLDC)
  rCommand(SensorSetup, DIGITAL)
return



